/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.PropinsiDao;
import com.portofolio.dto.PropinsiDto;
import com.portofolio.entity.Propinsi;
import com.portofolio.entity.vo.PropinsiId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class PropinsiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private PropinsiDao propinsiDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(PropinsiDto propinsiDto) {
		result.clear();
		PropinsiId id = new PropinsiId();
		id.setKdPropinsi(getIdTerahirByNegara(Propinsi.class, "kdPropinsi"));
		id.setKdNegara(getKdNegara());
		Propinsi propinsi = CommonUtil.findOne(propinsiDao, id);
		if (CommonUtil.isNullOrEmpty(propinsi)) {
			propinsi = new Propinsi();
			BeanUtils.copyProperties(propinsiDto, propinsi);
			propinsi.setNoRec(generateUuid32());
			propinsi.setVersion(1);
			propinsi.setId(id);
			propinsi = propinsiDao.save(propinsi);
			result.put("propinsi", propinsi);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("propinsi.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(PropinsiDto propinsiDto, Integer kdPropinsi, Integer version) {
		result.clear();
		PropinsiId id = new PropinsiId();
		id.setKdPropinsi(kdPropinsi);
		id.setKdNegara(getKdNegara());
		Propinsi propinsi = CommonUtil.findOne(propinsiDao, id);
		if (CommonUtil.isNotNullOrEmpty(propinsi)) {
			if (version < propinsi.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(propinsiDto, propinsi);
			propinsi.setVersion(version);
			propinsi = propinsiDao.save(propinsi);
			result.put("propinsi", propinsi);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaPropinsi,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaPropinsi)) {
			pageRes = propinsiDao.findAllList(getKdNegara(), namaPropinsi, statusEnabled, pageReq);
		} else {
			pageRes = propinsiDao.findAllList(getKdNegara(), statusEnabled, pageReq);
		}
		result.put("propinsi", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdPropinsi(Integer kdPropinsi) {
		result.clear();
		result.put("propinsi", propinsiDao.findByKdPropinsi(getKdNegara(), kdPropinsi, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdPropinsi, Integer version) {
		result.clear();
		PropinsiId id = new PropinsiId();
		id.setKdPropinsi(kdPropinsi);
		id.setKdNegara(getKdNegara());
		Propinsi propinsi = CommonUtil.findOne(propinsiDao, id);
		if (CommonUtil.isNotNullOrEmpty(propinsi)) {
			if (version < propinsi.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			propinsi.setStatusEnabled(false);
			propinsi.setVersion(version);
			propinsi = propinsiDao.save(propinsi);
			result.put("propinsi", propinsi);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	public Map<String, Object> findByKdNegara(Integer kdNegara) {
		result.clear();
		result.put("propinsi",propinsiDao.findByKdNegara( getKdNegara(), CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;

	}


}
